<?php
// This sample shows that when you try to insert an emoji (the strange character in the "INSERT INTO") in a non-UTF8MB4 table,
// Then mySQL fails. So use UTF8MB4 whenever you let users store a text in the DB
$dsn = 'mysql:host=127.0.0.1;dbname=test';
$user = 'root';
$password = '';
$pdo = new PDO($dsn, $user, $password, array(
	PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES utf8mb4",
	PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_CLASS,
	// Seems not to work
	PDO::ATTR_STRINGIFY_FETCHES => false,
	// Required for PDO to throw exceptions of SQL SIGNAL
	PDO::ATTR_EMULATE_PREPARES => true,
	PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
$pdo->query("SET time_zone = \"+00:00\"");

$pdo->query('START TRANSACTION');
$ps = $pdo->prepare('INSERT INTO utf8mb4 (message) VALUES (?)');
$ps->execute(array('🐉'));
$pdo->query('COMMIT');
// $pdo->query('ROLLBACK');